;************************************************
;LEKCJA  10	- DEKODER ADRESW
;PRZYKAD 7	- WYW. 7-SEG. - NIEPENE DEKODOWANIE
;************************************************

SEG_ON EQU	P1.6	;wczenie wywietlacza 7-segm.
LED	EQU	P1.7
KEY	EQU	P3.5	;odczyt klawiatury

;Pami wewntrzna RAM
DISPLAY		EQU	30H
KEY_LAST	EQU	DISPLAY+6

	LJMP	START
	ORG	100H
START:

	CLR	A
	MOV	DISPLAY,A		;wpisz 0 do pamici
	MOV	DISPLAY+1,A		;danych wszystkich
	MOV	DISPLAY+2,A		;wskanikw
	MOV	DISPLAY+3,A
	MOV	DISPLAY+4,A
	MOV	DISPLAY+5,A
	MOV	DISPLAY+6,A

;***********************
	MOV	R1,#CSDS+7	;adres wyboru wskanika
				;modyfikowany +7 aby
				;mona go byo zmieni
				;na adres danych wskanika
;***********************

LOOP_DISP:			;ustaw dane do wyw.
				;na wskaniku 1
	MOV	R0,#DISPLAY	;adres pobierania kodw
	MOV	R2,#7		;licznik - il. wskanikw
	MOV	R3,#00000001B ;wybr wskanika
				  ;- kod 1 z 8
LOOP:
	SETB	SEG_ON		;wycz poprzedni
				;wskanik
	MOV	A,R3		;nr wskanika (1z8)
	MOVX	@R1,A		;wpisz wybrany wskanik

;***********************
	INC	R1		;adres danych wskanika
;***********************
	MOV	A,@R0		;dane wskanika
	CJNE	R3,#01000000B,SEG	;czy 7 wskanik
	SJMP	LEDS		;tak-LEDY
				;nie ma zamiany na kod
SEG:
	LCALL	GET_COD7	;zamiana cyfry na kod
LEDS:
	MOVX	@R1,A		;wpisanie kodu zapalanych
				;segmentw do buforu
				;danych wskanika
	CLR	SEG_ON		;wczenie wskanika
;***********************
	DEC	R1		;adres wyboru wskanika
;***********************
	MOV	C,KEY		;wstpny odczyt klawisza
	MOV	A,#1		;odczekanie 1ms-wiecenie
	LCALL	DELAY_MS	;jednego wskanika

	JC	KEY_ON		;kontrola jednoznacznoci
	JB	KEY,KEY_END	;odczytu klawisza

KEY_OFF:
	MOV	A,R3		;klawisz zwolniony
	CPL	A
	ANL	KEY_LAST,A	;zeruj odpowiedni bit
	SJMP	KEY_END

KEY_ON:
	JNB	KEY,KEY_END
	MOV	A,R3		;klawisz nacinity
	ANL	A,KEY_LAST
	JNZ	KEY_END		;klawisz by nacinity
				;bez reakcji

	MOV	A,R3		;klawisz by zwolniony
	ORL	KEY_LAST,A	;ustaw odpowiedni bit
	INC	@R0		;zwiksz licznik
				;nacini - liczb na
				;odpowiednim wskaniku
KEY_END:
	MOV	A,R3
	RL	A		;numeru nastpnego
	MOV	R3,A		;wskanika (kod 1 z 8)
	INC	R0		;adres danych nastpnego
				;wskanika

	DJNZ	R2,LOOP		;kolejne wiecenie
				;siedmiu wskanikw
	SJMP	LOOP_DISP	;zacznij od wskanika 1

;**************************************
;Podprogram zamienia cyfr na kod 7-segmentowy
GET_COD7:
	ANL	A,#0FH		;tabela kodw 0..15
	INC	A		;pomi rozkaz RET
	MOVC	A,@A+PC		;pobierz kod
	RET

COD_7SEG:
	DB	03FH		;kod znaku 0
	DB	006H		;kod znaku 1
	DB	05BH		;kod znaku 2
	DB	04FH		;kod znaku 3
	DB	066H		;kod znaku 4
	DB	06DH		;kod znaku 5
	DB	07DH		;kod znaku 6
	DB	007H		;kod znaku 7
	DB	07FH		;kod znaku 8
	DB	06FH		;kod znaku 9
	DB	077H		;kod znaku A
	DB	07CH		;kod znaku b
	DB	039H		;kod znaku C
	DB	05EH		;kod znaku d
	DB	079H		;kod znaku E
	DB	071H		;kod znaku F
