;************************************************
;LEKCJA  11	- TIMERY MIKROKONTROLERA
;PRZYKAD 7	- POMIAR CZASU
;************************************************

LED	EQU	P1.7

;********* Ustawienie TIMERw *********
;TIMER 0
T0_G	EQU	1	;GATE
T0_C	EQU	0	;COUNTER/-TIMER
T0_M	EQU	3	;MODE (0..3)
TIM0	EQU	T0_M+T0_C*4+T0_G*8
;TIMER 1
T1_G	EQU	0	;GATE
T1_C	EQU	0	;COUNTER/-TIMER
T1_M	EQU	3	;MODE (0..3)
TIM1	EQU	T1_M+T1_C*4+T1_G*8

TMOD_SET	EQU	TIM0+TIM1*16
;**************************************

	LJMP	START
	ORG	100H
START:
	MOV	TMOD,#TMOD_SET		;Timer 0 jako
					;2 timery 8-bitowe
	LCALL	LCD_CLR

LOOP:
	CLR	A
	MOV	TL0,A		;zerowanie TIMERw
	MOV	TH0,A		;TL0 i TH0
	CLR	TF0
	CLR	TF1

	LCALL	WAIT_ENTER	;potwierdzenie gotowoci
				;do pomiarw

	LCALL	LCD_CLR
	MOV	DPTR,#TEXT	;czekaj na rozpoczcie
	LCALL	WRITE_TEXT	;transmisji

	JB	INT0,$		;start Timerw gdy INT0=0
	SETB	TR0
	SETB	TR1

	JNB	INT0,$		;stop Timerw po impulsie
	JB	INT0,$		;dodatnim na wejciu INT0
	CLR	TR0
	CLR	TR1

DISPLAY:			;wywietlenie zmierzonych
	LCALL	LCD_CLR		;czasw
	MOV	DPTR,#TEXT1
	LCALL	WRITE_TEXT
	
	MOV	A,#' '
	JNB	TF1,TIME1_OK ;znacznik przepenienia
	MOV	A,#'*'		 ;Timera TH0
TIME1_OK:
	LCALL	WRITE_DATA
	MOV	A,TH0		;czas zmierzony przez
	LCALL	WRITE_HEX	;Timer TH0

	MOV	DPTR,#TEXT0
	LCALL	WRITE_TEXT

	MOV	A,#' '
	JNB	TF0,TIME0_OK ;znacznik przepenienia
	MOV	A,#'*'		 ;Timera TL0
TIME0_OK:
	LCALL	WRITE_DATA
	MOV	A,TL0		;czas zmierzony przez
	LCALL	WRITE_HEX	;Timer TL0

	MOV	A,#' '
	LCALL	WRITE_DATA
	SJMP	LOOP

TEXT:
	DB	'TRANSMIT ...',0
TEXT0:
	DB	' TL0=',0
TEXT1:
	DB	'TH0=',0
