;************************************************
;LEKCJA  12	- SYSTEM PRZERWA 8051
;PRZYKAD 5 - WYWIETLACZ 7-SEGM. Z KLAWIATUR
;************************************************

SEG_ON		EQU	P1.6	;wczenie wyw.7-segm.
KEY		EQU	P3.5

;******* Pami wewntrzna RAM ********
KEY_SET		EQU	20H	;przekazanie danych o
				;klawiszach z przerwania
				;do programu gwnego
FLAGA	EQU	KEY_SET+1	;zestaw flag bitowych
K_TEST EQU	FLAGA.0		;testowanie klawisza

DISPLAY		EQU	30H	;pami danych dla wyw.
LEDY	EQU	DISPLAY+6	;pami danych dla diod
KEY_LAST	EQU	LEDY+1 ;nacinite klawisze

STOS	EQU	60H

;********* Ustawienie TIMERw *********
;TIMER 0
T0_G	EQU	0	;GATE
T0_C	EQU	0	;COUNTER/-TIMER
T0_M	EQU	1	;MODE (0..3)
TIM0	EQU	T0_M+T0_C*4+T0_G*8
;TIMER 1
T1_G	EQU	0	;GATE
T1_C	EQU	0	;COUNTER/-TIMER
T1_M	EQU	0	;MODE (0..3)
TIM1	EQU	T1_M+T1_C*4+T1_G*8

TMOD_SET	EQU	TIM0+TIM1*16

TH0_SET		EQU	256-4	;czas 4*256 = 1024 cykle
TL0_SET 	EQU	0	;= ok.1ms

;************** MACRA *****************
BANK0	MACRO		;ustawienie banku 0 rejestrw
	CLR	RS0	;(z banku 1)
	MACEND

BANK1	MACRO		;ustawienie banku 1 rejestrw
	SETB	RS0	;(z banku 0)
	MACEND
;**************************************

	LJMP	START

;********* Przerwanie Timer 0 *********
	ORG	0BH
	PUSH	PSW
	PUSH	ACC
	BANK1			;uycie banku 1 rejestrw

	MOV	TH0,#TH0_SET  ;ustawienie TH0 na 1ms

	JB	K_TEST,KEY_ON ;czy klawisz odczytany
	JB	KEY,KEY_END	  ;jednoznacznie
KEY_OFF:
	MOV	A,R3		;klawisz zwolniony
	CPL	A
	ANL	KEY_LAST,A	;zeruj odpowiedni bit
	SJMP	KEY_END

KEY_ON:
	JNB	KEY,KEY_END
	MOV	A,R3		;klawisz nacinity
	ANL	A,KEY_LAST
	JNZ	KEY_END		;klawisz by nacinity

	MOV	A,R3		;klawisz by zwolniony
	ORL	KEY_LAST,A	;ustaw odpowiedni bit
	ORL	KEY_SET,A	;przeka informacj do
				;programu gwnego

KEY_END:
	MOV	A,R3
	RL	A		;nastpny wskanik (1z8)
	MOV	R3,A
	INC	R0		;adres danych dla
				;nastpnego wskanika

	DJNZ	R2,DIS_END	;czy ostatni wskanik
				;tak - ustaw dane dla 1
	MOV	R0,#DISPLAY	;adres danych
	MOV	R3,#1		;wybr wskanika-kod 1z8
	MOV	R2,#7		;liczba wskanikw
DIS_END:

	SETB	SEG_ON		;wyczenie wskanika

	MOV	A,R3		;aktualny wskanik (1z8)
	MOVX	@R1,A		;wpisz do bufora wyboru

	INC	R1		;adres bufora danych
	MOV	A,@R0		;dane dla wskanika
	CJNE	R3,#40H,SEG	;czy 7 wskanik
	SJMP	LEDS		;tak-diody-nie ma zamiany
SEG:
	ACALL	GET_COD7	;zamiana danych na kod
LEDS:
	MOVX	@R1,A		;wpisanie kodu segmentw

	CLR	SEG_ON		;wczenie wskanika
	DEC	R1		;adres bufora wyboru

	MOV	C,KEY		;wstpny odczyt klawisza
	MOV	K_TEST,C	;przechowanie informacji
				;do nastpnego przerwania

	POP	ACC
	POP	PSW
	RETI

;**************************************
GET_COD7:
	ANL	A,#0FH		;tabela kodw 0..15
	INC	A		;ominicie rozkazu RET
	MOVC	A,@A+PC		;pobranie kodu z tabeli
	RET

COD_7SEG:
	DB	03FH		;kod znaku 0
	DB	006H		;kod znaku 1
	DB	05BH		;kod znaku 2
	DB	04FH		;kod znaku 3
	DB	066H		;kod znaku 4
	DB	06DH		;kod znaku 5
	DB	07DH		;kod znaku 6
	DB	007H		;kod znaku 7
	DB	07FH		;kod znaku 8
	DB	06FH		;kod znaku 9
	DB	077H		;kod znaku A
	DB	07CH		;kod znaku b
	DB	039H		;kod znaku C
	DB	05EH		;kod znaku d
	DB	079H		;kod znaku E
	DB	071H		;kod znaku F

;**************************************
	ORG	100H
START:
	MOV	SP,#STOS

	CLR	A		;wpisanie 0	
	MOV	DISPLAY,A	;na wszystkie wskaniki
	MOV	DISPLAY+1,A
	MOV	DISPLAY+2,A
	MOV	DISPLAY+3,A
	MOV	DISPLAY+4,A
	MOV	DISPLAY+5,A

	MOV	KEY_LAST,A	;stan pocztkowy klawiszy
	MOV	KEY_SET,A	;wszystkie zwolnione

	BANK1			;rejestry banku1
				;dla obsugi wywietlacza
	MOV	R0,#DISPLAY	;adres danych
	MOV	R1,#CSDS+7	;adres wyboru wskanika
				;z moliwoci zamiany na
				;adres danych wskanika
	MOV	R2,#7		;liczba wskanikw
	MOV	R3,#1		;wybr wskanika-kod 1z8
	BANK0

	MOV	TMOD,#TMOD_SET		;Timer 0 liczy czas
	MOV	TH0,#TH0_SET		;Timer 0 na 1ms
	MOV	TL0,#TL0_SET
	SETB	TR0			;start Timera

	SETB	EA		;zezwolenie na przerwanie
	SETB	ET0		;od Timera 0


	LCALL	LCD_CLR
	MOV	R0,#DISPLAY+5 ;adres danych wyw.
	MOV	LEDY,#1		;kursor wyw. 7-seg
				;zrobiony na ledach

LOOP:				;reakcja na klawisze
				;testowane w przerwaniu
	JBC	KEY_SET.0,K_ENTER
	JBC	KEY_SET.1,K_ESC
	JBC	KEY_SET.2,K_PRAWO
	JBC	KEY_SET.3,K_GORA
	JBC	KEY_SET.4,K_DOL
	JBC	KEY_SET.5,K_LEWO
	SJMP	LOOP

K_ENTER:		;przepisanie znaku wskazanego
			;kursorem na wywietlacz LCD
	MOV	A,@R0
	ANL	A,#0FH
	ORL	A,#30H
	LCALL	WRITE_DATA
	SJMP	LOOP
	
K_ESC:			;ustawienie kursora (diody)
			;na pozycji 1 wyw. 7-seg
	MOV	R0,#DISPLAY+5
	MOV	LEDY,#1
	SJMP	LOOP
	
K_PRAWO:		;przesunicie kursora
			;o 1 pozycj w prawo
	CJNE	R0,#DISPLAY,K_P1
	SJMP	LOOP
K_P1:
	DEC	R0
	MOV	A,LEDY
	RL	A
	MOV	LEDY,A
	SJMP	LOOP
		
K_GORA:			;zwikszenie o 1 wartoci
			;na wskaniku wybranym kursorem
	INC	@R0
	SJMP	LOOP

K_DOL:			;zmniejszenie o 1 wartoci
			;na wskaniku wybranym kursorem
	DEC	@R0
	SJMP	LOOP

K_LEWO:			;przesunicie kursora
			;o 1 pozycj w lewo
	CJNE	R0,#DISPLAY+5,K_L1
	SJMP	LOOP
K_L1:
	INC	R0
	MOV	A,DISPLAY+6
	RR	A
	MOV	DISPLAY+6,A
	SJMP	LOOP	
