;************************************************
;LEKCJA  13	- STEROWNIK TRANSMISJI SZEREGOWEJ
;PRZYKAD 7	- ODBIR Z PARZYSTOCI
;************************************************

LED	EQU	P1.7

;********* Ustawienie TIMERw *********
;TIMER 0
T0_G	EQU	0	;GATE
T0_C	EQU	0	;COUNTER/-TIMER
T0_M	EQU	0	;MODE (0..3)
TIM0	EQU	T0_M+T0_C*4+T0_G*8
;TIMER 1
T1_G	EQU	0	;GATE
T1_C	EQU	0	;COUNTER/-TIMER
T1_M	EQU	2	;MODE (0..3)
TIM1	EQU	T1_M+T1_C*4+T1_G*8

TMOD_SET	EQU	TIM0+TIM1*16

;******* Transmisja Szeregowa *********
TR_M	EQU	3	;tryb transmisji (1..3)
TR_R	EQU	1	;zezwolenie na odbir

SCON_SET	EQU	TR_M*64+TR_R*16

;SMOD=1
;TIMER1=57600/300bodw=192
TH1_SET		EQU	256-192
TL1_SET		EQU	256-192
;**************************************

	LJMP	START
	ORG	100H
START:

	MOV	SCON,#SCON_SET		;port szeregowy
	ORL	PCON,#80H		;SMOD=1
	MOV	TMOD,#TMOD_SET		;Timer 1 dla
	MOV	TH1,#TH1_SET		;transmisji	
	MOV	TL1,#TL1_SET
	SETB	TR1			;start Timera

	LCALL	LCD_CLR
LOOP:
	JNB	RI,$		;czy odebrany znak
	CLR	RI
	MOV	A,SBUF		;pobierz znak

	JB	RB8,PAR		;sprawd parzysto
				;odebran
	JNB	P,PAR_OK	;porwnaj z parzystoci
				;znaku
	SJMP	ERROR

PAR:
	JNB	P,ERROR

PAR_OK:				;parzysto prawidowa
	SETB	LED
	LCALL	WRITE_DATA	;wywietl znak na LCD
	SJMP	LOOP

ERROR:				;bd parzystoci
	CLR	LED		;zapal diod TEST
	SJMP	LOOP
