;************************************************
;LEKCJA  15	- STEROWNIK PRZERWA DSM-51
;PRZYKAD 2	- ODBIR RS-485
;************************************************

;********* Ustawienie TIMERw *********
;TIMER 0
T0_G	EQU	0	;GATE
T0_C	EQU	0	;COUNTER/-TIMER
T0_M	EQU	2	;MODE (0..3)
TIM0	EQU	T0_M+T0_C*4+T0_G*8
;TIMER 1
T1_G	EQU	0	;GATE
T1_C	EQU	0	;COUNTER/-TIMER
T1_M	EQU	0	;MODE (0..3)
TIM1	EQU	T1_M+T1_C*4+T1_G*8

TMOD_SET	EQU	TIM0+TIM1*16

;******* Transmisja Szeregowa *********
;Timer/Bit = Fosc[Hz] /12 /V[bod]
BIT_TIME	EQU	11059200/12/4800
T0_SET		EQU	256-BIT_TIME
T0_STRT		EQU	256-BIT_TIME/2
IN		EQU	P3.4
;**************************************

	LJMP	START

;********* Przerwanie Timer 0 *********
	ORG	0BH
	PUSH	PSW
	PUSH	ACC
	DJNZ	R2,NEXT
	SJMP	LAST

;********* Przerwanie INT 1 ***********
	ORG	13H
	PUSH	PSW
	PUSH	ACC
				;obsuga sterownika 		
	MOVX	A,@R1		;odczyt numeru przerwania
	ANL	A,#03H
	MOVX	@R1,A		;skasowanie przerwania

	CJNE	A,#1,INT_END ;czy przerwanie nr 1
	SETB	TR0		;wcz Timer 0
	CLR	EX1		;blokuj przerwanie INT1

INT_END:
	POP	ACC
	POP	PSW
	RETI

;****** Przerwanie Timer 0 - cd *******
LAST:				;odebrano cay bajt
				;aktualnie trwa bit stopu
	CLR	TR0		;wycz Timer 0
	MOV	TL0,#T0_STRT ;ustawienia dla kolejnej
	MOV	R2,#10		;transmisji

	MOV	A,#1
	MOVX	@R1,A		;skasowanie przerwania
	SETB	EX1

	MOV	A,R7		;odebrany bajt na LCD
	LCALL	WRITE_DATA

	POP	ACC
	POP	PSW
	RETI

NEXT:				;kolejny bit transmisji
	MOV	C,IN		;pobierz bit
	MOV	A,R7
	RRC	A		;dopisz do poprzednich
	MOV	R7,A
	POP	ACC
	POP	PSW
	RETI

;***************************************
	ORG	100H
START:

	LCALL	LCD_CLR

	MOV	TMOD,#TMOD_SET		;Timer 0 dla
	MOV	TH0,#T0_SET		;transmisji	
	MOV	TL0,#T0_STRT		;1/2 bitu startu
	MOV	R2,#10			;licznik bitw

;*** zerowanie sterownika przerwa ****
	MOV	R1,#CSAD	;skasowanie przerwania
	MOVX	A,@R1		;w przetworniku A/C

	MOV	R1,#CSIC	;skasowanie przerwa
	CLR	A		;w sterowniku
	MOVX	@R1,A		;A=0 (IAD)
	INC	A
	MOVX	@R1,A		;A=1 (IOI)
	INC	A
	INC	A
	MOVX	@R1,A		;A=3 (IX)

	SETB	EA		;wcz przerwania
	SETB	ET0		;od Timera 0
	SETB	EX1		;i z wejcia INT1

	SJMP	$
