;************************************************
;LEKCJA  17	- PRZETWARZANIE A/C I C/A
;PRZYKAD 5	- ZAMIANA REZYSTANCJA -> CZAS
;************************************************

;********** Ustawienie 8255 ***********
;PORT A
;A0 =0 -> pomiar rezystora wzorcowego R1=2k 1%
;A1 =0 -> pomiar czujnika temperatury R2 - KTY10-6
;A2 =0 -> pomiar czujnika temperatury R3 - KTY10-6
;A3 =0 -> rozadowanie kondensatora pomiarowego
;PORT C
;C0 = 0->1 - koniec pomiaru = przerwanie IPB
;C4 =1 -> podgrzewanie czujnika temperatury R3
;C5 =0 -> blokada przerwania IPA

PA_M	EQU	0	;TRYB 0..2
PA_D	EQU	0	;OUT->0, IN->1
PCA_D	EQU	0	;OUT->0, IN->1
PB_M	EQU	0	;TRYB 0..1
PB_D	EQU	0	;OUT->0, IN->1
PCB_D	EQU	1	;OUT->0, IN->1

PA	EQU	PA_M*4+PA_D*2+PCA_D
PB	EQU	PB_M*4+PB_D*2+PCB_D
SET_8255	EQU	80H+PA*8+PB

;********* Ustawienie TIMERw *********
;TIMER 0 - czas adowania kondensatora
T0_G	EQU	0	;GATE
T0_C	EQU	0	;COUNTER/-TIMER
T0_M	EQU	1	;MODE (0..3)
TIM0	EQU	T0_M+T0_C*4+T0_G*8
;TIMER 1
T1_G	EQU	0	;GATE
T1_C	EQU	0	;COUNTER/-TIMER
T1_M	EQU	0	;MODE (0..3)
TIM1	EQU	T1_M+T1_C*4+T1_G*8

TMOD_SET	EQU	TIM0+TIM1*16

;**************************************
	LJMP	START
	ORG	0100H
START:

	MOV	R0,#CS55D	;ustawienie ukadu 8255
	MOV	R1,#CS55C
	MOV	A,#SET_8255
	MOVX	@R0,A
	CLR	A		;wyczenie grzaki
	MOVX	@R1,A

	MOV	TMOD,#TMOD_SET		;Timer 0 - 16bit
	MOV	R0,#CS55A	;adres kluczy pomiarowych

;**************************************
LOOP:
	MOV	A,#07H		;rozadowanie
	MOVX	@R0,A		;kondensatora
	MOV	A,#10
	LCALL	DELAY_MS
	MOV	A,#0FH		;wyczenie kluczy
	MOVX	@R0,A

	MOV	TL0,#0		;zerowanie Timera 0
	MOV	TH0,#0

	MOV	A,#0DH		;pomiar rezystora R2
	MOVX	@R0,A		;rozpoczcie pomiaru
	SETB	TR0		;start licznika
	
POMIAR_LOOP:			;oczekiwanie na
	MOVX	A,@R1		;naadowanie kondensatora
	JNB	ACC.0,POMIAR_LOOP

	CLR	TR0		;kondensator naadowany
	MOV	A,#0FH		;- koniec pomiaru
	MOVX	@R0,A		;wyczenie kluczy
	LCALL	LCD_CLR
	MOV	A,TH0
	LCALL	WRITE_HEX
	MOV	A,TL0
	LCALL	WRITE_HEX

	MOV	A,#5		;pomiary co 0.5 sek
	LCALL	DELAY_100MS
	SJMP	LOOP
