;************************************************
;LEKCJA  19	- PAMI EEPROM
;PRZYKAD 2	- ZAPIS
;************************************************

BUZ	EQU	P1.5

;********** Ustawienie 8255 ***********
;PORT C -> EEPROM
;PC7 -> CS
;PC6 -> SK
;PC5 -> DI
;PC3 <- DO

PA_M	EQU	0	;TRYB 0..2
PA_D	EQU	0	;OUT->0, IN->1
PCA_D	EQU	0	;OUT->0, IN->1
PB_M	EQU	0	;TRYB 0..1
PB_D	EQU	0	;OUT->0, IN->1
PCB_D	EQU	1	;OUT->0, IN->1

PA	EQU	PA_M*4+PA_D*2+PCA_D
PB	EQU	PB_M*4+PB_D*2+PCB_D
SET_8255	EQU	80H+PA*8+PB

;********* Instrukcje EEPROMU *********
WRITE	EQU	40H	;zapis
EWEN	EQU	30H	;zezwolenie na zapis
EWDS	EQU	00H	;blokada zapisu

;************** MACRA *****************
CLOCK	MACRO			;impuls na PC6 (SK)
	MOV	A,#6*2+1
	MOVX	@R0,A
	DEC	A
	MOVX	@R0,A
	MACEND

CS_ON	MACRO			;wczenie sygnau CS
	MOV	A,#7*2+1
	MOVX	@R0,A
	MACEND

CS_OFF MACRO			;wyczenie sygnau CS
	MOV	A,#7*2
	MOVX	@R0,A
	MACEND

DI_1	MACRO			;linia danych=1
	MOV	A,#5*2+1
	MOVX	@R0,A
	MACEND

DI_0	MACRO			;linia danych=0
	MOV	A,#5*2
	MOVX	@R0,A
	MACEND

;**************************************
	LJMP	START
	ORG	100H
START:

	MOV	R0,#CS55D	;inicjalizacja 8255
	MOV	A,#SET_8255
	MOVX	@R0,A

	DEC	R0
	MOV	A,#0H		;CS=0, SK=0, DI=0
	MOVX	@R0,A
	INC	R0

	LCALL	LCD_CLR

LOOP:
	MOV	R1,#30
	LCALL	WAIT_KEY	;adres w EEPROMie

	MOV	@R1,A
	LCALL	LCD_CLR
	MOV	A,#'('
	LCALL	WRITE_DATA
	MOV	A,@R1
	LCALL	WRITE_HEX	;wypisz adres na LCD
	MOV	DPTR,#TEXT
	LCALL	WRITE_TEXT

	INC	R1		;bajty do zapisu
	ACALL	GET_BYTE	;do EEPROMu
	INC	R1
	ACALL	GET_BYTE

	MOV	A,#EWEN		;zezwolenie na zapis
	ACALL	SEND_INSTR

	CS_ON			;zapis do EEPROMu
	CLOCK
	DI_1
	CLOCK
	DEC	R1
	DEC	R1
	MOV	A,@R1		;adres uzupeniony
	ADD	A,#WRITE	;instrukcj WRITE
	ACALL	WR_8B

	INC	R1		;zapis do EEPROMu
	MOV	A,@R1
	ACALL	WR_8B
	INC	R1
	MOV	A,@R1
	ACALL	WR_8B
	DI_0
	CS_OFF

	CS_ON			;programowanie EEPROMu
	CLR	BUZ
	DEC	R0
BUSY:
	MOVX	A,@R0
	JNB	ACC.3,BUSY
	INC	R0	
	SETB	BUZ
	CS_OFF

	MOV	A,#EWDS		;blokada zapisu
	ACALL	SEND_INSTR

	SJMP	LOOP

;*********** PODPROGRAMY **************
WR_8B:				;zapis 8 bitw do EEPROMu
	MOV	R7,#8
W_LOOP:
	RLC	A		;kolejny bit do C
	PUSH	ACC

	MOV	A,#5		;bit 5 w porcie C - DI
	RLC	A		;dodanie wartoci bitu
	MOVX	@R0,A		;wysanie na port C
	CLOCK			;wpis bitu do EEPROMu

	POP	ACC
	DJNZ	R7,W_LOOP
	RET

;******************
SEND_INSTR:			;wysanie instrukcji
	PUSH	ACC		;1-bajtowej do EEPROMu

	CS_ON
	CLOCK
	DI_1
	CLOCK			;bit startu

	POP	ACC		;instrukcja
	ACALL	WR_8B
	DI_0	
	CS_OFF		
	RET

;******************
GET_BYTE:			;odczyt 2 klawiszy jako
	LCALL	WAIT_KEY	;danych 8-bitowych
	SWAP	A		;1 klawisz starsze 4 bity
	MOV	@R1,A
	SWAP	A
	ACALL	WRITE_DATA_HEX

	LCALL	WAIT_KEY
	PUSH	ACC
	XCHD	A,@R1		;2 klawisz modsze 4 bity
	POP	ACC
	ACALL	WRITE_DATA_HEX
	RET

WRITE_DATA_HEX:			;zapis danych jako liczby
	ADD	A,#30H		;szesnastkowej
	CJNE	A,#3AH,$+3
	JC	WR_D
	ADD	A,#7
WR_D:
	LCALL	WRITE_DATA
	RET

;******************
TEXT:
	DB	') <- ',0
