;************************************************
;LEKCJA  20	- ZEGAR CZASU RZECZYWISTEGO
;PRZYKAD 2	- ZAPIS
;************************************************

;********** Ustawienie 8255 ***********
;PA0..PA3 - szyna danych OUT
;PA4 - 0 - DANE OUT
;      1 - DANE IN
;PA5 - 1 - CS
;PA6 - 1 - STOP

;PC4 - 1 - RD
;PC5 - 1 - WR
;PC6 - 1 - AWR
;PC7 - 1 - TEST

;PB0..PB3 - szyna danych IN

;PC0 - (IPB) impulsy 1024Hz
;PC3 - (IPA) impulsy 1Hz
;PC1 - BUSY

PA_M	EQU	0	;TRYB 0..2
PA_D	EQU	0	;OUT->0, IN->1
PCA_D	EQU	0	;OUT->0, IN->1
PB_M	EQU	0	;TRYB 0..1
PB_D	EQU	1	;OUT->0, IN->1
PCB_D	EQU	1	;OUT->0, IN->1

PA	EQU	PA_M*4+PA_D*2+PCA_D
PB	EQU	PB_M*4+PB_D*2+PCB_D
SET_8255	EQU	80H+PA*8+PB

;**************************************
;stae sterujce RTC do wystawiania na port A
DATA_IN		EQU	00110000B	;odczyt z RTC
DATA_OUT	EQU	00100000B	;zapis do RTC
CS_OFF		EQU	00010000B	;odczenie RTC

;ustawianie pojedynczych bitw w porcie C 8255
;poprzez wpisywanie staych pod adres CS55D
CLR_RD		EQU	4*2		;zeruj ODCZYT
SET_RD		EQU	4*2+1		;ustaw ODCZYT
SET_WR		EQU	5*2+1		;ustaw ZAPIS
SET_AWR		EQU	6*2+1		;ustaw ZAPIS ADRESU
;**************************************

	LJMP	START
	ORG	100H
START:

	MOV	R0,#CS55A	;inicjalizacja 8255
	MOV	R1,#CS55D
	MOV	A,#SET_8255
	MOVX	@R1,A

	MOV	A,#CS_OFF	;odczenie RTC
	MOVX	@R0,A
	DEC	R1
	CLR	A		;PC4..7=0->RD,WR,AWR,TEST
	MOVX	@R1,A		
	INC	R1

	LCALL	LCD_CLR

LOOP:
	LCALL	WAIT_KEY	;adres w RTC
	PUSH	ACC
	LCALL	LCD_CLR
	MOV	A,#'('
	LCALL	WRITE_DATA
	POP	ACC
	PUSH	ACC
	LCALL	WRITE_HEX	;wypisz adres na LCD
	MOV	DPTR,#TEXT1
	LCALL	WRITE_TEXT

	LCALL	WAIT_KEY	;dane do rejestru RTC
	MOV	B,A
	LCALL	WRITE_HEX	;wypisz dane na LCD

	DEC	R1		;kontrola stanu BUSY
BUSY:
	MOVX	A,@R1
	JNB	ACC.1,BUSY
	INC	R1

	POP	ACC		;zapis adresu
	ADD	A,#DATA_OUT
	MOVX	@R0,A	
	MOV	A,#SET_AWR
	MOVX	@R1,A
	DEC	A
	MOVX	@R1,A

	MOV	A,B		;zapis danych do rejestru
	ADD	A,#DATA_OUT
	MOVX	@R0,A	
	MOV	A,#SET_WR
	MOVX	@R1,A
	DEC	A
	MOVX	@R1,A

	MOV	A,#DATA_IN	;odczyt danych z rejestru
	MOVX	@R0,A
	MOV	A,#SET_RD
	MOVX	@R1,A
	INC	R0
	MOVX	A,@R0
	DEC	R0
	PUSH	ACC
	MOV	A,#CLR_RD
	MOVX	@R1,A

	MOV	A,#CS_OFF	;odczenie RTC
	MOVX	@R0,A

	MOV	DPTR,#TEXT2
	LCALL	WRITE_TEXT
	POP	ACC		;dane na LCD
	ANL	A,#0FH
	LCALL	WRITE_HEX
	SJMP	LOOP

TEXT1:
	DB	') <- ',0
TEXT2:
	DB	' => ',0
